/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.bert;

import org.mitre.pam.util.pdifHashtables.PDIFConn;
import org.mitre.pam.util.draw.BlockConnector;
import org.mitre.pam.util.draw.Block;


/**
 * This class is a directed line which connects two other objects.
 * 
 * @version 2, 20 May 1998
 * @version 1.01, 18 Dec 1997
 * @version 1, 10 Dec 1997
 * @author Sam Gerstein
 * @author Nazario Irizarry
 */
class Edge extends BlockConnector{
	private PDIFConn data = null;


	/**
	 * creates a new Edge
	 * @param parentApp - tells the new Edge where the managing app is.
	 * @param from - the tail of the new Edge
	 * @param to - the head of the new Edge
	 */
	public Edge(Block from, Block to, PDIFConn data) {
		super(from, to);
		this.data = data;
	}	

	public PDIFConn getData() {
		return data;
	}		

	public void setData(PDIFConn data) {
		this.data = data;
	}
}