/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.daemon;

import java.util.*;
import java.io.*;

import org.mitre.pam.interfaces.*;

import org.mitre.pam.executive.ExecGlobal;

/**
* This daemon allows executive checkpoints
* to be scheduled.
*
* @author Nazario Irizarry, Jr.
*/
public class CheckpointDaemon extends DaemonBase {

	public CheckpointDaemon() {
	/*
	* Set update period and default last update so that we
	* don't immediatly checkpoint -- allows time to discover errors
	*/
		setPeriod(30*60*60+59);	// every 30 minutes approx
		updateComputer.setLastUpdateTime(System.currentTimeMillis()+5*60*1000);
	}
/**
* Upon request we issue callback into exec to get it
* to checkpoint.
*/
	public void doDaemonTask() {
		((ExecToController)exec).checkPoint();
	}

}