/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.executive;

/**
 * Provides a way to add text to the descriptive string of an existing exception
 *
 * @author  Nazario Irizarry
 * @version 1
 */
public
class AmplifyingException extends Exception {
	private Throwable other;

/**
* Builds this exception with a message that is the concatenation of additionalString and other.getMessage()
*/
    public AmplifyingException(String additionalString, Throwable other) {
		super("("+additionalString+")"+other.getMessage());
		this.other = other;
		
    }

/**
* A proxy method that prints the other stack trace
*/
    public void printStackTrace() { 
    	other.printStackTrace();
    }

/**
* A proxy method that prints the other stack trace
*/
    public void printStackTrace(java.io.PrintStream s) {
    	other.printStackTrace(s);
    }

/**
* A proxy method that prints the other stack trace
*/
    public void printStackTrace(java.io.PrintWriter s) { 
    	other.printStackTrace(s);
	}
}
