package org.mitre.pam.getter;

import java.io.ByteArrayInputStream;
import java.io.File;

import java.util.Enumeration;

import org.mitre.pam.executive.Exec;

import org.mitre.pam.interfaces.ContainerProduct;
import org.mitre.pam.interfaces.IDictionary;
import org.mitre.pam.interfaces.Product;
import org.mitre.pam.interfaces.Reporter;

import org.mitre.pam.product.view.DictionaryProduct;
import org.mitre.pam.product.view.HashtableProduct;
import org.mitre.pam.product.view.VectorProduct;
import org.mitre.pam.product.view.ProductStore;


import org.mitre.pam.getter.DictProdFilter;


/**
* This class represents a base class for any PIM that will be receiving DictionaryProducts.
*
* @author John R. Fantry
*
* Note: Some code copied from source originally written by Jones Leung.
*/
public abstract class DictionaryBasePIM extends PIMShell1 {

  /**
  * This function restores all dictionaries contained in the object and then
  * pushes the product through the system.
  */
  public void processObject(Object obj) {
    if(obj != null) {
      if(obj instanceof IDictionary) {
//        restoreDictionary((IDictionary)obj); ?? no longer required i think, naz
      }
      else if(obj instanceof DictionaryProduct) {
        if(((DictionaryProduct)obj).isValid()) {
          pushProductToAllClients((Product)obj);
        }
        else {
          warning("Received invalid DictionaryProduct, associated dictionary is unavailable.");
        }
      }
      else if(obj instanceof ContainerProduct) {
        ((Product)obj).apply(new DictProdFilter(reporter));
        if(!(obj == null)) {
          if(((ContainerProduct)obj).prune()) {
            if(((ContainerProduct)obj).size() == 1) {
              if(obj instanceof VectorProduct) {
                pushProductToAllClients(((VectorProduct)obj).elementAt(0));
              }
              else if(obj instanceof HashtableProduct) {
                Enumeration enum = (Enumeration)((HashtableProduct)obj).getContent();
                pushProductToAllClients((Product)enum.nextElement());
              }
              else {
                warning("Received unknown type of container product.");
              }
            }
            else {
              pushProductToAllClients((Product)obj);
            }
          }
        }
      }
      else if(obj instanceof Product) {
        pushProductToAllClients((Product)obj);
      }
    }
  }

}