/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.interfaces;

import java.util.Hashtable;

/**
* All sources have a list of sinks.  They do
* not maintain the list. The exec maintains the list. <p>
*
* @author Nazario Irizarry, Jr.
*/
public class FlowEvent  {
/**
* Identifies the type of event.
*/
	public static String OUTPUT_READY = "outputReady";
/**
* Identifies the type of event.
*/
	public static String NEED_INPUT = "needInput";
/**
* The product that this event is about
*/
	protected Product theProduct;
/**
* The source that prepared the product
*/
	protected Agent theAgent;
/**
* The source that prepared the product
*/
	protected String theType;
/**
* Create an event
*/
	public FlowEvent(Agent theAgent, Product theProduct, String eventType) {
		this.theProduct = theProduct;
		this.theAgent = theAgent;
		this.theType = eventType;
	}
/**
* Create an event
*/
	public FlowEvent(Agent theAgent, String eventType) {
		this.theProduct = null;
		this.theAgent = theAgent;
		this.theType = eventType;
	}
/**
* Get the product that is ready
*/
	public Product getProduct(){
		return theProduct;
	}
/**
* Get the source that produced the product
*/
	public Agent getAgent(){
		return theAgent;
	}
/**
* Get the type of event
*/
	public String getType(){
		return theType;
	}
}
