/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.interfaces;

/**
* Identifies objects that can be scheduled. <p>
*
* @author Nazario Irizarry, Jr.
*/
public interface Schedulable extends Agent{
	public final static String HAS_SCHEDULE = "meta_hasSchedule"; 
/**
* @return the next command/time to be executed
* @return null if  not enabled
*/
	public ScheduledCommand getNextScheduleCommand();
/**
* Tell the agent that it needs to active as soon as possible.
* This may not have any meaning for some classes of agents.
* The default behavior here is to do nothing.
*/
	public void activateASAP();
/**
* Tell the agent that it needs to active at the specified time.
*
* @param timeInMillis time in milliseconds at which to activate
*/
	public void activateAt(long timeInMillis);

}