/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.interfaces;

/**
* Defines a Sink with a list of inputs.  Provides unbrokered access to the list.
* Sinks contain but do
* not maintain the list. The exec maintains the list.
*
* @author Nazario Irizarry, Jr.
*/
public interface Sink  {

/**
* Push product to the sink. Must be implemented
* as a synchronized method to prevent conflicts
* if two asyncrhonous agents call putProduct().
*
* @param product to put
*/
//	public void putProduct(Product product); // now part of base classes, interface is pleasePutProduct
/**
* Checks the specified putToken
* to see if it is valid, before putting the product.
* This prevents asyncrhonouse sources from sneaking product
* in while the sink is in the middle of another put or task.
*
* @param product to put
* @param the task that is asking for permission to put, if the task does not have 
* permission it will be blocked
*/
	public void pleasePutProduct(Product product, Task task);
}
