/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.interfaces;
/**
* An agent that implements this interface is notified by the exec
* as inputs or outputs are added or removed<p>
*
* @author Nazario Irizarry, Jr.
*/

public interface WantsConnectionChanges  {
	/**
	* An input to the agent was removed
	*/
	public void aSourceWasRemoved(ConnectedAgent source);
			
	/**
	* An input to the agent was added
	*/
	public void aSourceWasAdded(ConnectedAgent source);

	/**
	* An output to the agent was removed
	*/
	public void aSinkWasRemoved(ConnectedAgent sink);
			
	/**
	* An output to the agent was added
	*/
	public void aSinkWasAdded(ConnectedAgent sink);
	
	/**
	* Notification that the instance is no longer being used
	*/
	public void youHaveBeenDiscarded();

}
