/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.monitor.utils;

import java.awt.Image;
import java.awt.Canvas;
import java.awt.Toolkit;
import java.awt.MediaTracker;
import java.awt.Graphics;

/**
 * This simple class overrides Canvas to draw an image.  It resizes 
 * itself to the size of the image.
 *
 * @author Michael DeCorpo
 */
public class ImageCanvas extends Canvas
{
  Image image;

  public ImageCanvas()
  {
  }

  public ImageCanvas(String imagename)
  {
    this.image = Toolkit.getDefaultToolkit().getImage(imagename);
    if (this.image == null)
      return;

    waitForImage(this.image);    
    setSize(this.image.getWidth(this),this.image.getHeight(this));
  }

  public ImageCanvas(Image image)
  {
    this();
    this.image = image;
    setSize(this.image.getWidth(this),this.image.getHeight(this));
  }

  private void waitForImage(Image image)
  {
    MediaTracker tracker = new MediaTracker(this);
    tracker.addImage(image,0);
    try {
      tracker.waitForID(0);
    }
    catch(InterruptedException e) {}
  }

  /**
   * Override paint to draw the image
   */
  public void paint(Graphics g) 
  {
    if (image == null)
      return;
    g.drawImage(image,0,0,this);
  }

}
