/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.productVisitor;

import java.net.URL;

import java.util.*;

import org.mitre.pam.interfaces.Product;
import org.mitre.pam.interfaces.ProductVisitor;


/**
* Gets a list of all products that contain URL's.
*
* @author John Fantry
*/
public class AsFlatURLList implements ProductVisitor {
	Vector list;


/**
*
*/
  public AsFlatURLList () {
	}

	public void visit(Product product) {
		list = new Vector(50);
		process(product, list);
	}

/**
* This enumeration points to products whose content is a URL
*/
  public Enumeration getURLProductList() {
		return list.elements();
	}

	private void process(Object product, Vector list) {
		if (product == null)
			return;

		if (product instanceof Product)
			process((Product) product, list);
	}

	private void process(Product product, Vector list) {
//    System.out.println(" AsFlatURLList render");
		if (product == null)
			return;
		Object content = product.getContent();
		/*
		* vector contents
		*/
		if (content instanceof Enumeration) {
			Enumeration enum = (Enumeration) content;
//      System.out.println(" AsFlatURLList, vector content, size "+cv.size());
			while (enum.hasMoreElements()) {
				process(enum.nextElement(), list);
			}
		}

/*
* URL contents
*/
    else if (content instanceof URL) {
//      System.out.println(" AsFlatURLList, URL");
			list.addElement(product);
		}
	}
}