/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.util;

/**
* An AttributeKey is a class designed to allow
* "efficient" access to product attributes
* regardless of the way the attribute values
* are stored.  The current implementation
* works in conjunction with the SortedHash class.
*/

public final class AttributeKey {
	String name;
/**
* Don't use this value - the implementation may change
*/
	Object referenceObject1; 
/**
* Don't use this value - the implementation may change
*/
	int index1;
/**
* Don't use this value - the implementation may change
*/
	boolean extension;
/**
* To build an attribute key you need a string name.
* Everything needed by core to "optimize" fetch and insert
* is done at runtime.
*/
	public AttributeKey(String name) {
		if (name == null || name.length() ==0)
		throw new IllegalArgumentException("attributeName must not be null in the constructor to AttributeKey");
		this.name = name;
	}
/**
* @return the name of the attribute represented by this key.
*/
	final public String getName() {
		return name;
	}

/**
* @return the name of the attribute represented by this key.
*/
	final public String toString() {
		return name;
	}
}