/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.util;

import java.util.Date;
import java.util.Random;
/**
* Code to help verify legitimate numbers.
*
* @author Nazario Irizarry, Jr.
*/

public class DownloadNumber {

	
	Random rand = new Random(System.currentTimeMillis());
	
	public static void main(String[] args) {
		DownloadNumber dn = new DownloadNumber();
		

		String a = dn.makeDownloadNumber();
//		System.out.println("number = "+a);
		try { Thread.sleep(6000); } catch (InterruptedException ignore) {}
//		System.out.println("valid = "+dn.verifyDownloadNumber(a));
	}
	
	public String makeDownloadNumber() {
		StringBuffer b = new StringBuffer(80);
		String timeStr = Long.toString(System.currentTimeMillis()*43);
		int len = timeStr.length();

//		System.out.println("timeStr="+timeStr);
		
		for (int i=0; i< 9; i++) {
			int n = rand.nextInt();
			if (n < 0) n = -n;
			n %= 10;
			b.append(Integer.toString(n));
			
			
			b.append(timeStr.charAt(--len));
		}
		
		return b.toString();
	}

	public boolean verifyDownloadNumber(String number, Date date) {
		return verifyDownloadNumber(number);
	}

	public boolean verifyDownloadNumber(String number) {
		String timeStr = Long.toString(System.currentTimeMillis()*43);
		
//		System.out.println("timeStr="+ timeStr);
		
		StringBuffer b = new StringBuffer(80);
		StringBuffer ref = new StringBuffer(80);
		int len = number.length();
		int rpos = timeStr.length()-10;

		for (int i=0; i< 9; i++) {
			b.append(number.charAt(--len));
			ref.append(timeStr.charAt(++rpos));
			len--;
		}
		
//		System.out.println("b="+b);

		long n = Long.parseLong(b.toString());
		long r = Long.parseLong(ref.toString());
		
//		System.out.println("n="+Long.toString(n));
//		System.out.println("r="+Long.toString(r));

		long dif = n - r;


		if (dif < 0)
			dif = - dif;
		dif /= 43000;

//		System.out.println("diff="+Long.toString(dif));
			
		return (dif < 120); // allow 120 second difference
		
	}

}