package mitre.pam.util;
/**
* Creates a simple window(s) to
* write messages to. <p>
*
* @author Nazario Irizarry, Jr.
*/

import java.awt.*;
import java.util.Hashtable;

public class Log extends Frame{

	static final boolean ENABLED = true;

	static Hashtable allLogs = new Hashtable(10);
	
	TextArea text = new TextArea(10,40);
	
	static final String DEFAULT_NAME = "Generic Log";

	private Log() {
		this(DEFAULT_NAME);
	}

	private Log(String logName) {
		super(logName);
		if(ENABLED) {
			reshape(10,10,100,100);
			setLayout(new FlowLayout());
			add(text);
			text.appendText("Log Start");
			text.appendText("\n");
//			pack();
			show();	
			allLogs.put(logName, this);
		}
	}
	
	public static void log(String s) {
		log(DEFAULT_NAME, s);
	}

	public static void log(String logName, String s) {
		if (ENABLED) {
			Log thisLog = (Log) getLog(logName);
			thisLog.text.appendText(s);
			thisLog.text.appendText("\n");
		}
	}

	public static void setText(String s) {
		setText(DEFAULT_NAME, s);
	}

	public static void setText(String logName, String s) {
		if (ENABLED) {
			Log thisLog = (Log) getLog(logName);
			thisLog.text.setText(s);
		}
	}

	public static void appendText(String s) {
		appendText(DEFAULT_NAME, s);
	}

	public static void appendText(String logName, String s) {
		if (ENABLED) {
			Log thisLog = (Log) getLog(logName);
			thisLog.text.appendText(s);
		}
	}

	private static Log getLog(String logName) {
		if (ENABLED) {
			Log thisLog = (Log) allLogs.get(logName);
			if (thisLog == null) {
				thisLog = new Log(logName);
			}
			return thisLog;
		}
		else
			return null;
	}
	
/*	how do you detect window size changed by user?  don't know
	public boolean handleEvent(Event e) {
	System.out.println("log window id= "+e.id);
		return false;
	}
	
	public void resize(int width, int height) {
		System.out.println("resize 1");
		super.resize(width,height);
	}

	public void resize(Dimension d) {
		System.out.println("resize 2");
		super.resize(d);
	}

	public void reshape(int x, int y, int width, int height) {
		System.out.println("reshape 3");
		super.reshape(x,y,width,height);
	}
*/
	protected void finalize() {
		if (ENABLED) {
			text=null;
			dispose();
		}
	}
}