/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.util.draw;
/*
	A basic extension of the java.applet.Applet class
 */

import java.awt.*;
import java.applet.*;
import java.util.Hashtable;
import org.mitre.pam.interfaces.Reporter;


public class DrawPanel extends Frame
{
	public static final int DRAW_PANEL_VERSION = 1;
	DrawParent drawParent;
	PopupMenu doPopup;
/*
	public static void main(String[] args) {

		DrawPanel theFrame = new DrawPanel();
		DrawParent dp = theFrame.getDrawParent();

		theFrame.setVisible(true);
		
		Block b1,b2,b3;
		b1 = new Block();
		b1.setOnce(100,100, "one");
		dp.add(b1);

		b2 = new Block();
		b2.setOnce(70,70, "two");
		dp.add(b2);

		b3 = new Block();
		b3.setOnce(50,60, "three");
		dp.add(b3);
		
		BlockConnector l1 = new BlockConnector(b1, b2);
		BlockConnector l2 = new BlockConnector(b1, b3);
		dp.add(l1);
		dp.add(l2);
		
		dp.addDrawListener(new TestAction());

		PopupMenu pop = new PopupMenu("Do...");
		MenuItem newPIM = new MenuItem("New PIM");
		Menu newJuggler = new Menu("New Juggler");
		MenuItem passThru = new MenuItem("passThru");
		newJuggler.add(passThru);
		pop.add(newPIM);
		pop.add(newJuggler);
		theFrame.setCommandPopup(pop);
		theFrame.drawParent.setOpenAreaPopup(pop);
	}
*/
	
	public DrawPanel() {
		init();
		drawParent = new DrawParent();		
		drawParent.setSize(600,600);
		scrollPane1Main.add(drawParent);
		scrollPane1Main.invalidate();
		scrollPane1Main.setScrollPosition(0,0);
		drawParent.setStatusLine(label1Status);
		drawParent.setVisible(true);
		validate();
		//{{INIT_MENUS
		//}}
	}
	
	public void setReporter(Reporter reporter) {
		drawParent.setReporter(reporter);
	}
	public void setStatus(String msg) {
		label1Status.setText(msg);
	}
	
	public int stringWidth(String str) {
		return drawParent.getFontMetrics(drawParent.getFont()).stringWidth(str);
	}
	
	public DrawParent getDrawParent() {
		return drawParent;
	}
	
	
	public void setCommandPopup(PopupMenu menu) {
		if (doPopup != null) {
//			buttonDoFunc.remove(doPopup);
			this.remove(doPopup);
		}
		doPopup = menu;
		
		this.add(menu);
//		buttonDoFunc.add(menu);
		buttonDoFunc.setEnabled(true);
	}

	public void setCommandPopupEnabled(boolean state) {
		buttonDoFunc.setEnabled(state);
	}
	
	/**
	* tell draw panel to clean up for exit
	*/
	public void finish() {
		scrollPane1Main.removeMouseListener(aSymMouse);
		buttonSubmit.removeActionListener(lSymAction);
		buttonReload.removeActionListener(lSymAction);
		buttonDoFunc.removeActionListener(lSymAction);
		drawParent.finish();
		drawParent = null;
	}
	
	public void init()
	{
		// Take out this line if you don't use symantec.itools.net.RelativeURL or symantec.itools.awt.util.StatusScroller
//		symantec.itools.lang.Context.setApplet(this);
	
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		GridBagLayout gridBagLayout;
		gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		setVisible(false);
		setSize(426,266);
		setFont(new Font("Dialog", Font.PLAIN, 10));
		scrollPane1Main = new java.awt.ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
		scrollPane1Main.setBounds(0,17,426,227);
		GridBagConstraints gbc;
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.gridwidth = 3;
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		gbc.anchor = GridBagConstraints.SOUTHEAST;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)getLayout()).setConstraints(scrollPane1Main, gbc);
		add(scrollPane1Main);
		label1Status = new java.awt.Label("Status line");
		label1Status.setBounds(5,244,364,22);
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.gridwidth = 2;
		gbc.weightx = 2.0;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,5,0,0);
		((GridBagLayout)getLayout()).setConstraints(label1Status, gbc);
		add(label1Status);
		buttonSubmit = new java.awt.Button();
		buttonSubmit.setLabel("Submit");
		buttonSubmit.setBounds(369,246,52,17);
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 2;
		gbc.anchor = GridBagConstraints.EAST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,5);
		((GridBagLayout)getLayout()).setConstraints(buttonSubmit, gbc);
		add(buttonSubmit);
		buttonReload = new java.awt.Button();
		buttonReload.setLabel("Reload");
		buttonReload.setBounds(369,0,52,17);
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 0;
		gbc.anchor = GridBagConstraints.EAST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,5);
		((GridBagLayout)getLayout()).setConstraints(buttonReload, gbc);
		add(buttonReload);
		buttonDoFunc = new java.awt.Button();
		buttonDoFunc.setLabel("Do...");
		buttonDoFunc.setBounds(5,0,38,17);
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.anchor = GridBagConstraints.EAST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,5,0,0);
		((GridBagLayout)getLayout()).setConstraints(buttonDoFunc, gbc);
		add(buttonDoFunc);
		//}}
	
		//{{REGISTER_LISTENERS
		aSymMouse = new SymMouse();
		scrollPane1Main.addMouseListener(aSymMouse);
		lSymAction = new SymAction();
		buttonSubmit.addActionListener(lSymAction);
		buttonReload.addActionListener(lSymAction);
		buttonDoFunc.addActionListener(lSymAction);
		//}}
		
	}
//		SymMouse aSymMouse = new SymMouse();
//		SymAction lSymAction = new SymAction();
		SymMouse aSymMouse;
		SymAction lSymAction;
	
	//{{DECLARE_CONTROLS
	java.awt.ScrollPane scrollPane1Main;
	java.awt.Label label1Status;
	protected java.awt.Button buttonSubmit;
	protected java.awt.Button buttonReload;
	protected java.awt.Button buttonDoFunc;
	//}}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
		}
	}

	

	class SymFocus extends java.awt.event.FocusAdapter
	{
		public void focusLost(java.awt.event.FocusEvent event)
		{
		}

		public void focusGained(java.awt.event.FocusEvent event)
		{
		}
	}

	

	

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseExited(java.awt.event.MouseEvent event)
		{
		}

		public void mouseEntered(java.awt.event.MouseEvent event)
		{
		}

		public void mouseReleased(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == scrollPane1Main)
				scrollPane1Main_MouseReleased(event);
		}

		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == scrollPane1Main)
				scrollPane1Main_MousePressed(event);
		}
	}

	void scrollPane1Main_MousePressed(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
	}

	void scrollPane1Main_MouseReleased(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
	}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == buttonSubmit)
				buttonSubmit_ActionPerformed(event);
			else if (object == buttonReload)
				buttonReload_ActionPerformed(event);
			else if (object == buttonDoFunc)
				buttonDoFunc_ActionPerformed(event);
		}
	}
	void buttonSubmit_ActionPerformed(java.awt.event.ActionEvent event)
	{
		drawParent.notifyOfCommand(new DrawEvent(DrawEvent.SAVE));		
	}

	void buttonReload_ActionPerformed(java.awt.event.ActionEvent event)
	{
		drawParent.notifyOfCommand(new DrawEvent(DrawEvent.LOAD));
	}

	void buttonDoFunc_ActionPerformed(java.awt.event.ActionEvent event)
	{
		if (doPopup != null)
			doPopup.show(this,20,20);
//			doPopup.show(buttonDoFunc,20,20);
	}

	
	//{{DECLARE_MENUS
	//}}
}

class TestAction implements org.mitre.pam.util.draw.DrawListener
{
	public void blockConnectRequest(DrawEvent evt){
		Block from = evt.getFromBlock();
		Block to = evt.getToBlock();
		System.out.println("connect request from "+from+" ->to-> "+to);
	}
	public void doCommand(DrawEvent evt){
		System.out.println("command request: "+evt.getId());
	}
	public void blockMoveTo(DrawEvent evt){
		Block b = evt.getBlock();
		System.out.println("block move: "+b);
	}
}
