package org.mitre.pam.util.nntp;

import java.io.*;
import java.util.*;

import org.mitre.pam.util.PrintCRLFWriter;
import org.mitre.pam.util.smtp.MailComposer;

/**
* This interface defines required functions common to all news composers.
* Additional methods are inherited from the MailComposer interface.
*
* @author Jones Leung
*/
public interface NewsComposer extends MailComposer {    
/**
* Add a single newsgroup to the newsgroup line of the news article being composed.
*/
    public void addNewsgroup(String newsgroup);
    
/**
* @return An Enumeration of the "newsgroups" field of the news article.
*/
    public Enumeration getNewsgroups();
    
/**    
* This method is not applicable to Usenet news articles.<p>
* It is only here to implement the MailComposer interface.    
* @throws   RuntimeException    if this unsupported method is called
*/
    public void setTo (String to) throws RuntimeException;

/**    
* This method is not applicable to Usenet news articles.<p>
* It is only here to implement the MailComposer interface.    
* @throws   RuntimeException    if this unsupported method is called
*/
    public String getTo () throws RuntimeException;
}