package org.mitre.pam.daemon.rules;

import java.util.Enumeration;

import org.mitre.pam.interfaces.Agent;
import org.mitre.pam.interfaces.ExecToEditor;
import org.mitre.pam.executive.ExecGlobal;

import jess.Context;
import jess.Funcall;
import jess.Rete;
import jess.ReteException;
import jess.RU;
import jess.Value;
import jess.ValueVector;
import jess.Userfunction;


/**
* This JESS extension will assert all active modules (PIM, DIM, Juggler, and Daemon).
*
* @author John R. Fantry
*/
class AssertAllAgents implements Userfunction {

	private String m_name = "assertAllAgents";
	ExecToEditor exec;
	AssertAgent assertAgent;

  AssertAllAgents(AssertAgent assertAgent) {
		this.assertAgent = assertAgent;
		exec = ExecGlobal.getExec();
  }

  public Value call(ValueVector vv, Context context) throws ReteException {

	assertAgent.acceptAllNewNodes();
	
    Enumeration enums[] = new Enumeration[4];
    enums[0] = exec.getListOfActiveModules(exec.PIM);
    enums[1] = exec.getListOfActiveModules(exec.DIM);
    enums[2] = exec.getListOfActiveModules(exec.JUGGLER);
    enums[3] = exec.getListOfActiveModules(exec.DAEMON);

    for(int i=0; i<enums.length; i++) {
      Enumeration e = enums[i];
      while(e.hasMoreElements()) {
        assertAgent.assertOneAgent((Agent)e.nextElement(), context);
      }
    }

    return Funcall.TRUE();
  }

  public String name() {
    return m_name;
  }
}