package org.mitre.pam.daemon.rules;

import org.mitre.pam.daemon.rules.PropertiesTable;
import org.mitre.pam.executive.ExecGlobal;
import org.mitre.pam.interfaces.Agent;
import org.mitre.pam.interfaces.Memento;
import org.mitre.pam.interfaces.ExecToEditor;
import org.mitre.pam.interfaces.Sink;
import org.mitre.pam.interfaces.Source;
import org.mitre.pam.interfaces.ConfigurationListener;
import org.mitre.pam.interfaces.ConfigurationEvent;
import org.mitre.pam.interfaces.MementoEvent;
import org.mitre.pam.interfaces.MementoListener;
import org.mitre.pdif.eventParser.ValueList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;
import jess.Clearable;
import jess.Context;
import jess.Fact;
import jess.Funcall;
import jess.RU;
import jess.Resetable;
import jess.Rete;
import jess.ReteException;
import jess.Userfunction;
import jess.Value;
import jess.ValueVector;

/**
* @author Nazario Irizarry
*/

class AssertReport implements Userfunction
{
	AssertAgent aa;
	
	AssertReport(ExecToEditor exec, AssertAgent aa) {
		this.aa = aa;
	}
	
/*
* SYNTAX: (assertAgent <pam-agent-id> ) - aserts the agent
* SYNTAX: (assertAgent)  - builds the template only
*/
	public Value call(ValueVector vv, Context context) throws ReteException {
		return aa.callSpecial(vv, context, true);
	}
	
	public String name() { 
		return "assertReportAgent"; 
	}

}

