package org.mitre.pam.daemon.rules;

import java.awt.*;
import java.io.*;
import java.applet.*;
import java.net.*;

import jess.*;

/**
* Simple main to run Jess
*
* @author Nazario Irizarry, Jr. 3/22/98
*/
public class MyMain 
{
  
  public static void main(String[] argv) 
  {
    MyDisplay nd = new MyDisplay("Jess input");
    Rete rete = new Rete(nd);
    
    try
      {
        rete.executeCommand("(printout t (jess-version-string) crlf crlf)");
      } 
    catch(ReteException re) {}


    // Load in optional packages, but don't fail if any are missing.
    String [] packages = { "jess.StringFunctions",
                           "jess.PredFunctions",
                           "jess.MultiFunctions", 
                           "jess.MiscFunctions",
                           "jess.MathFunctions",
                           "jess.BagFunctions",
                           "jess.reflect.ReflectFunctions",
                           "jess.view.ViewFunctions" };

    for (int i=0; i< packages.length; i++)
      {
        try
          {
            rete.addUserpackage((Userpackage)
                                Class.forName(packages[i]).newInstance());
          }
        catch (Throwable t) { /* Optional package not present */ }
      }

    InputStream fis = nd.sin;

    if (fis != null) 
      {
        Jesp j = new Jesp(fis, rete);
        while (true)

          {
            try
              {
                // Argument is 'true' for prompting, false otherwise
                j.parse(false);
              }
            catch (ReteException re) 
              {
                re.printStackTrace(rete.errStream());
              }
            catch (ArrayIndexOutOfBoundsException ai) 
              {
                rete.errStream().println("Wrong number of args in funcall?");
                ai.printStackTrace(rete.errStream());
              }
            catch (NullPointerException npe) 
              {
                rete.errStream().println("Wrong number of args in funcall?");
                npe.printStackTrace(rete.errStream());
              }
            catch (Exception e) 
              {
                rete.errStream().println("Unexpected exception:");
                e.printStackTrace(rete.errStream());
              }
          }
      }
  }
}
