package org.mitre.pam.daemon.rules;

/**
* Allows a waiting process to proceed if the trigger has been set
*/

class SyncSemaphore {
	private boolean triggered;
	private boolean autorun = true;
	
	synchronized void trigger() {
		if (triggered)
			return;
		if (!autorun)
			return;
		triggered = true;
		notify();
	}

	synchronized void clear() {
		triggered = false;
	}
	
	synchronized void waitForTrigger() throws InterruptedException{
		while (!triggered) {
			wait();
		}
		triggered = false;
	}
	
	void setAutorun(boolean autorun) {
		this.autorun = autorun;
	}
}