/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.getter;

import org.mitre.pam.interfaces.Product;
import org.mitre.pam.executive.Exec;
import org.mitre.pam.product.view.BasicProduct;
import org.mitre.pam.product.view.HashtableProduct;
import org.mitre.pam.product.view.VectorProduct;
import org.mitre.pam.store.FileRef;


/**
* Generates an expired complex product for test purposes.
*
* @author Tim Taylor
* @author Jones Leung, modified 1/28/98 from original TestPIMComplex
* @author Nazario Irizarry, simplified 2/16/98 
*/

public class TestPIMExpired extends TestPIMComplex {
	private static String DEBUG_KEYWORD = "TestPIMExpired";
	private static long LIFETIME = 1; // lifetime in seconds
	
  public TestPIMExpired() {
	setProperty(META_GUI_GROUP, TestPIM1.TEST_CATEGORY);
    setDescription("provides a canned product that expires 1 second after it is created");
  }

  /**
   * Callback to receive a command.  We ignore the
   * command for now since we can only do one thing - fetch.
   */
	public Product doFetch(){
		Product theProduct = super.doFetch();
		bp1.setProperty(Product.PROPERTY_LIFETIME, LIFETIME);
		bp2.setProperty(Product.PROPERTY_LIFETIME, LIFETIME);
		bp3.setProperty(Product.PROPERTY_LIFETIME, LIFETIME);
		bp4.setProperty(Product.PROPERTY_LIFETIME, LIFETIME);

		try {
			Thread.sleep(1500); // wait to ensure expired product
		}
		catch (Exception e) {}
		return theProduct;
	}

}