/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.getter;

import java.io.File;


import org.mitre.pam.interfaces.Product;
import org.mitre.pam.interfaces.ProductFactory;
import org.mitre.pam.interfaces.ContainerProduct;

import org.mitre.pam.product.view.BasicProduct;
import org.mitre.pam.product.view.VectorProduct;
import org.mitre.pam.store.FileRef;


/**
* Generates a complex product with an index page for test purposes.
*
* @author Nazario Irizarry
*/

public class TestPIMIndexed extends TestPIMComplex {
	private static String DEBUG_KEYWORD = "TestPIMIndexed";
	
	public TestPIMIndexed() {
		setDescription("Create complex product with index html page (for testing)");
		setProperty(META_GUI_GROUP, TestPIM1.TEST_CATEGORY);
	}

	public Product doFetch(){
		ProductFactory fab = exec.getProductFactory();
		Product theProduct = super.doFetch();
		
		File file = makeFile("originalIndex.html", 
			"<html><body>This is an index to two of the html files. <br>"+
			"<A HREF=\"abc.html\">abc.html</a>"+
			"<A HREF=\"def.html\">abc.html</a>"+
			"<br>However, there are more files in the complete product.</html></body>"
			);
		Product bp = fab.makeProduct("The index page","contains html",new FileRef(file, file.lastModified(), file.getName()));
		
		((ContainerProduct)theProduct).addRootElement(bp); // adds page and marks it as index page
		return theProduct;
	}

}
