/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.getter;

import java.net.URL;
import org.mitre.pam.product.view.BasicProduct;

/*
* PIM that extends the simple TestPIM1 to return a fixed URL product.
* For test purposes.  <P>
*
* @author Jason Mathews
* @since iPAM 2.3.74
*/

public class TestPIMUrl extends TestPIM1 {

  public TestPIMUrl () {
    setDescription("Creates a URL product");
    setProperty(CONTENT,"http://www.cda.mews.org");
    metaStringInfo(CONTENT, "http://www.cda.mews.org", "This becomes the content of the product as a URL");
	setProperty(META_GUI_GROUP, TestPIM1.TEST_CATEGORY);
  }

  protected Object makeContent() {
    String content = getProperty("content");
    URL url = null;
    /*
     * URL content
     */
    try {
      url = new URL(content);
    } catch (java.net.MalformedURLException mue) {
      reporter.reportException(mue);
    }
    return url;
  }
}
