/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.monitor;

/**
 * A gui for editing the connections of Agents.
 *
 * @author Michael DeCorpo
 */

import java.awt.*;
import java.awt.event.*;

import java.util.Vector;
import java.util.Enumeration;
import java.lang.String;
import java.io.File;

import org.mitre.pam.interfaces.Agent;
import org.mitre.pam.interfaces.ConnectedAgent;
import org.mitre.pam.interfaces.Sink;
import org.mitre.pam.interfaces.Source;
import org.mitre.pam.interfaces.PIM;
import org.mitre.pam.interfaces.DIM;
import org.mitre.pam.interfaces.Juggler;
import org.mitre.pam.interfaces.ConfigurationEvent;
import org.mitre.pam.interfaces.ConfigurationListener;
import org.mitre.pam.interfaces.ExecToController;
import org.mitre.pam.interfaces.AdminTool;
import org.mitre.pam.util.EnabledTable;
import org.mitre.pam.executive.Module;
import org.mitre.pam.executive.ExecGlobal;

import org.mitre.pam.monitor.utils.ItemScroller;
import org.mitre.pam.monitor.utils.ImageCanvas;

public class AgentStateFrame extends Frame implements AdminTool
{
  static String IMAGEPATH = "Gui";

  ExecToController exec;

  ItemScroller is1,is2;
  
  // Used for addNotify check.
  boolean fComponentsAdjusted = false;
  
  org.mitre.pam.monitor.utils.ImageCanvas imagecanvas1, imagecanvas2;
  java.awt.Checkbox curAgentCheckbox;
  java.awt.Label outputsLabel;
  java.awt.Label inputsLabel;
  java.awt.Button activateSourcesButton;
  java.awt.Button deactivateSourcesButton;
  java.awt.Button activateSinksButton;
  java.awt.Button deactivateSinksButton;
  java.awt.Button stopButton;
  java.awt.Button refreshButton;
  
  java.awt.MenuBar mainMenuBar;

  java.awt.MenuItem refresh;
  java.awt.Menu menu2;
  java.awt.Menu pimm;
  java.awt.Menu jugglerm;
  java.awt.Menu dimm;
    
  java.awt.Checkbox inputs[];
  java.awt.Checkbox outputs[];
  
  java.awt.Panel inPanel, outPanel;

  java.awt.Panel buttonpan1, buttonpan2, middlepan, botpan;

  Vector pims, dims, jugglers;
  CheckboxMenuItem pimboxes[],dimboxes[],jugglerboxes[];

  Agent curagent;
  Vector sources, sinks;
  MultiEventListener multilistener;

  public void setExec(ExecToController exec) {
    this.exec = exec;
    exec.addConfigurationListener(multilistener);
    buildMenus();
  }

  public AgentStateFrame()
  {
    // This code is automatically generated by Visual Cafe when you add
    // components to the visual environment. It instantiates and initializes
    // the components. To modify the code, only use code syntax that matches
    // what Visual Cafe can generate, or Visual Cafe may be unable to back
    // parse your Java file into its visual environment.
    // Note: some of this code has been modified from what was generated by 
    // Visual Cafe.
    
    //{{INIT_CONTROLS
    
    multilistener = new MultiEventListener();
    GridBagLayout gbl = new GridBagLayout();
    setLayout(gbl);
    GridBagConstraints gbc;

    setVisible(false);
    setSize(insets().left + insets().right + 350,insets().top + insets().bottom + 225);
    setFont(new Font("Dialog", Font.PLAIN, 12));
    setBackground(new Color(12632256));
    setForeground(Color.black);

    is1 = new ItemScroller();
    is1.setBounds(insets().left + 12,insets().top + 12,250,90);
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.gridwidth = 2;
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;
    gbc.fill = GridBagConstraints.BOTH;
    gbl.setConstraints(is1,gbc);
    add(is1);
    
    is1.addItemListener(multilistener);
       
    middlepan = new Panel();
    middlepan.setBounds(insets().left,insets().top + 102,350,42); 
    middlepan.setLayout(null);

    File dir = ExecGlobal.getSupportDir(IMAGEPATH);
    String fname1 = new File(dir,"right.gif").getAbsolutePath();
    Image arrow1 = Toolkit.getDefaultToolkit().getImage(fname1); 
    imagecanvas1 = new ImageCanvas(arrow1);
    imagecanvas1.setBounds(middlepan.insets().left + 26,middlepan.insets().top,39,30);
    
    middlepan.add(imagecanvas1);

    curAgentCheckbox = new java.awt.Checkbox("");
    curAgentCheckbox.setBounds(middlepan.insets().left + 66,middlepan.insets().top + 4,203,36);
    curAgentCheckbox.setFont(new Font("Dialog", Font.PLAIN, 14));
    curAgentCheckbox.setForeground(new Color(255));
    curAgentCheckbox.setBackground(new Color(12632256));

    middlepan.add(curAgentCheckbox);
    curAgentCheckbox.addItemListener(multilistener);

    String fname2 = new File(dir,"down.gif").getAbsolutePath();
    Image arrow2 = Toolkit.getDefaultToolkit().getImage(fname2); 
    imagecanvas2 = new ImageCanvas(arrow2);

    imagecanvas2.setBounds(middlepan.insets().left + 276,middlepan.insets().top + 12,39,30);
    middlepan.add(imagecanvas2);

    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 1;
    gbc.gridwidth = 3;
    gbc.gridheight = 1;
    gbc.weightx = 1.0;
    gbc.weighty = 0.0;
    gbc.fill = GridBagConstraints.VERTICAL;
    gbl.setConstraints(middlepan,gbc);
    add(middlepan);
    
    is2 = new ItemScroller();
    is2.setBounds(insets().left + 88,insets().top + 148,250,90);
    
    gbc = new GridBagConstraints();
    gbc.gridx = 1;
    gbc.gridy = 2;
    gbc.gridwidth = 2;
    gbc.gridheight = 1;
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;
    gbc.fill = GridBagConstraints.BOTH;
    gbl.setConstraints(is2,gbc);
    add(is2);
    is2.addItemListener(multilistener);
    
    buttonpan1 = new Panel();
    GridBagLayout gridbag = new GridBagLayout();
    buttonpan1.setLayout(gridbag);

    inputsLabel = new java.awt.Label("Inputs:",Label.CENTER);
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;
    gridbag.setConstraints(inputsLabel,gbc);
    buttonpan1.add(inputsLabel);

    activateSourcesButton = new java.awt.Button();
    activateSourcesButton.setLabel("Activate all.");
    activateSourcesButton.setBackground(new Color(65535));
    activateSourcesButton.addActionListener(multilistener);
    
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 1;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.ipadx = 13;
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;
    gbc.anchor =  GridBagConstraints.NORTH;
    gridbag.setConstraints(activateSourcesButton,gbc);
    buttonpan1.add(activateSourcesButton);

    deactivateSourcesButton = new java.awt.Button();
    deactivateSourcesButton.setLabel("Deactivate all.");
    deactivateSourcesButton.setBackground(new Color(65280));
    deactivateSourcesButton.addActionListener(multilistener);

    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 2;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;
    gridbag.setConstraints(deactivateSourcesButton,gbc);
    buttonpan1.add(deactivateSourcesButton);

    gbc = new GridBagConstraints();
    gbc.gridx = 2;
    gbc.gridy = 0;
    gbc.ipadx = 10;
    gbc.ipady = 10;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.weightx = 0.0;
    gbc.weighty = 0.0;
    gbl.setConstraints(buttonpan1,gbc);
    add(buttonpan1);

    buttonpan2 = new Panel();
    gridbag = new GridBagLayout();
    buttonpan2.setLayout(gridbag);

    outputsLabel = new java.awt.Label("Outputs:",Label.CENTER);
    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;
    gridbag.setConstraints(outputsLabel,gbc);
    buttonpan2.add(outputsLabel);

    activateSinksButton = new java.awt.Button();
    activateSinksButton.setLabel("Activate all.");
    activateSinksButton.setBackground(new Color(65535));
    activateSinksButton.addActionListener(multilistener);

    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 1;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.ipadx = 13;
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;
    gridbag.setConstraints(activateSinksButton,gbc);
    buttonpan2.add(activateSinksButton);

    deactivateSinksButton = new java.awt.Button();
    deactivateSinksButton.setLabel("Deactivate all.");
    deactivateSinksButton.setBackground(new Color(65280));
    deactivateSinksButton.addActionListener(multilistener);

    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 2;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;
    gridbag.setConstraints(deactivateSinksButton,gbc);
    buttonpan2.add(deactivateSinksButton);

    gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 2;
    gbc.ipadx = 10;
    gbc.ipady = 10;
    gbc.weightx = 0.0;
    gbc.weighty = 0.0;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbl.setConstraints(buttonpan2,gbc);
    add(buttonpan2);

//    setTitle("Agent Connections");
    //}}
    
    //{{INIT_MENUS
    mainMenuBar = new java.awt.MenuBar();
    menu2 = new java.awt.Menu("Agents");
    pimm = new java.awt.Menu("Inputs");
    jugglerm = new java.awt.Menu("Jugglers");
    dimm = new java.awt.Menu("Outputs");
    menu2.add(pimm);
    menu2.add(jugglerm);
    menu2.add(dimm);
    menu2.addSeparator();
    refresh = new MenuItem("Refresh");
    menu2.add(refresh);
    refresh.addActionListener(multilistener);

    mainMenuBar.add(menu2);
    setMenuBar(mainMenuBar);
    //}}
    
    //{{REGISTER_LISTENERS
    SymWindow aSymWindow = new SymWindow();
    this.addWindowListener(aSymWindow);
    //}}
  }
  
  public AgentStateFrame(String title)
  {
    this();
    setTitle("Agent enables, "+title);
  }
  
  public synchronized void show()
  {
    move(50, 50);
    super.show();
  }
  
  static public void main(String args[])
  {
    (new AgentStateFrame()).show();
  }
  
  public void addNotify()
  {
    // Record the size of the window prior to calling parents addNotify.
    Dimension d = getSize();
    
    super.addNotify();
    
    if (fComponentsAdjusted)
      return;
    
    // Adjust components according to the insets
    setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
    Component components[] = getComponents();
    for (int i = 0; i < components.length; i++)
      {
	Point p = components[i].getLocation();
	p.translate(insets().left, insets().top);
	components[i].setLocation(p);
      }
    fComponentsAdjusted = true;
  }


  /**
   * This method will rebuild the items in the pim, dim and juggler menus.
   */
  public void buildMenus()
  {
    // get the pims, dims and jugglers and put them into the menu
    if (exec == null) 
      return;
    
    // remove all previous items and then build a Vector of all the pim names
    pimm.removeAll();
    pims = new Vector(10);
    Enumeration e = exec.getListOfActiveModules(exec.PIM);
    while(e.hasMoreElements()) {
      Agent a = (Agent) e.nextElement();
      pims.addElement(a);
    }

    // create a CheckboxMenuItem for each pim, put it in the menu, and then
    // register a listener for it
    CheckboxItemListener cil = new CheckboxItemListener();
    pimboxes = new CheckboxMenuItem[pims.size()];
    for (int i=0; i<pims.size(); i++) {
      pimboxes[i] = new CheckboxMenuItem(((Agent) pims.elementAt(i)).getId());
      pimm.add(pimboxes[i]);
      pimboxes[i].addItemListener(cil);
    }

    // remove all previous items and then build a Vector of all the dim names
    dimm.removeAll();
    dims = new Vector(10);
    e = exec.getListOfActiveModules(exec.DIM);
    while(e.hasMoreElements()) {
      Agent a = (Agent) e.nextElement();
      dims.addElement(a);
    }

    // create a CheckboxMenuItem for each dim, put it in the menu, and then
    // register a listener for it
    dimboxes = new CheckboxMenuItem[dims.size()];
    for (int i=0; i<dims.size(); i++) {
      dimboxes[i] = new CheckboxMenuItem(((Agent) dims.elementAt(i)).getId());
      dimm.add(dimboxes[i]);
      dimboxes[i].addItemListener(cil);
    }
    
    // remove all previous items and then build a Vector of all the juggler names
    jugglerm.removeAll();
    jugglers = new Vector(10);
    e = exec.getListOfActiveModules(exec.JUGGLER);
    while(e.hasMoreElements()) {
      Agent a = (Agent) e.nextElement();
      jugglers.addElement(a);
    }

    // create a CheckboxMenuItem for each juggler, put it in the menu, and then
    // register a listener for it
    jugglerboxes = new CheckboxMenuItem[jugglers.size()];
    for (int i=0; i<jugglers.size(); i++) {
      jugglerboxes[i] = new CheckboxMenuItem(((Agent) jugglers.elementAt(i)).getId());
      jugglerm.add(jugglerboxes[i]);
      jugglerboxes[i].addItemListener(cil);
    }

  }

  /**
   * This method takes the name(id) of an agent and places that agent under edit.
   * i.e. it is placed in the checkbox and it's sources and sinks are displayed
   * in the appropriate ItemScrollers.
   */
  public void displayAgent(String agent)
  {
    //System.out.println("display " + agent);

    Agent a = exec.getActiveAgent(agent);
    if (a == null)
      return;

    // uncheck current agent menu item if it is different from the agent we
    // want to display
    if ((curagent != null) && (!curagent.getId().equals(a.getId()))) {
      String id = curagent.getId();
      //System.out.println("unchecking " + id);
      if (curagent instanceof PIM) {
	for (int i=0; i<pimboxes.length; i++) {
	  if (pimboxes[i].getLabel().equals(id)) {
	    pimboxes[i].setState(false);
	    break;
	  }
	}
      }
      else if (curagent instanceof DIM) {
	for (int i=0; i<dimboxes.length; i++) {
	  if (dimboxes[i].getLabel().equals(id)) {
	    dimboxes[i].setState(false);
	    break;
	  }
	}
      }
      else if (curagent instanceof Juggler) {
	for (int i=0; i<jugglerboxes.length; i++) {
	  if (jugglerboxes[i].getLabel().equals(id)) {
	    jugglerboxes[i].setState(false);
	    break;
	  }
	}
      }
    }
	
    // build a new vector of sources and sinks for the agent and place them
    // in the ItemScroller
    if (a instanceof PIM) {
      sources = new Vector();
      sinks = new Vector();

      // clear top itemscroller
      Vector v = new Vector();
      Vector b = new Vector();
      is1.setItems(v,b);
      
      // get sinks and put them in botom itemscroller
      EnabledTable et = (EnabledTable) ((ConnectedAgent) a).getSinkList();
      Enumeration elems = et.allElements();
      while(elems.hasMoreElements()) {
	Module m = (Module) elems.nextElement();
	sinks.addElement(m);
	v.addElement(m.getId());
	b.addElement(new Boolean(m.isEnabled()));

      }
      is2.setItems(v,b);
      
      // make sure it's checked
      for (int i=0; i<pimboxes.length; i++) {
	if (pimboxes[i].getLabel().equals(a.getId())) {
	  pimboxes[i].setState(true);
	  break;
	}
      }
      
    }
    else if (a instanceof DIM) {
      sources = new Vector();
      sinks = new Vector();
      
      // clear bottom item scroller
      Vector v = new Vector();
      Vector b = new Vector();
      is2.setItems(v,b);

      // get sourcess and put them in top itemscroller
      //EnabledTable et = (EnabledTable) ((Sink) a).getSourceList();
      Enumeration enum = ((ConnectedAgent) a).getFullSourceElementEnumeration();
      while(enum.hasMoreElements()) {
	Module m = (Module) enum.nextElement();
	sources.addElement(m);
	v.addElement(m.getId());
	b.addElement(new Boolean(m.isEnabled()));
      }
      is1.setItems(v,b);

      // make sure it is checked
      for (int i=0; i<dimboxes.length; i++) {
	if (dimboxes[i].getLabel().equals(a.getId())) {
	  dimboxes[i].setState(true);
	  break;
	}
      }
    }
    else if (a instanceof Juggler) {
      sources = new Vector();
      sinks = new Vector();
      
      Vector v = new Vector();
      Vector b = new Vector();

      // build the sink vector and put it in the bottom ItemScroller
      EnabledTable et = (EnabledTable) ((ConnectedAgent) a).getSinkList();
      Enumeration elems = et.allElements();
      while(elems.hasMoreElements()) {
	Module m = (Module) elems.nextElement();
	sinks.addElement(m);
	v.addElement(m.getId());
	b.addElement(new Boolean(m.isEnabled()));
      }
      is2.setItems(v,b);
      
      v = new Vector();
      b = new Vector();

      // build the source vector and put it in the top ItemScroller
      Enumeration enum = ((ConnectedAgent) a).getFullSourceElementEnumeration();
      while(enum.hasMoreElements()) {
	Module m = (Module) enum.nextElement();
	sources.addElement(m);
	v.addElement(m.getId());
	b.addElement(new Boolean(m.isEnabled()));
      }
      is1.setItems(v,b);

      // make sure it is checked
      for (int i=0; i<jugglerboxes.length; i++) {
	if (jugglerboxes[i].getLabel().equals(a.getId())) {
	  jugglerboxes[i].setState(true);
	  break;
	}
      }

    }
    else
      return;

    // dont forget to check menu checkbox
    // change label of middle checkbox
    curAgentCheckbox.setLabel(a.getId());
    curAgentCheckbox.setState((new Boolean(a.getProperty(Agent.ENABLED))).booleanValue());

    // set the current agent to this agent
    curagent = a;

    // force a refresh
    curAgentCheckbox.invalidate();
    validate();
    }

  /**
   * This method will refresh the state of the gui based on the current
   * iPAM state.  It will rebuild the menus and redisplay the current agent
   */
  public void refreshState()
  {
    buildMenus();
    if (curagent != null)
      displayAgent(curagent.getId());
  }


  void AgentStateFrame_WindowClosing(java.awt.event.WindowEvent event)
  {
    setVisible(false);
  }
  
    
  /**
   * This class handles most of the event handling.  
   */
  class MultiEventListener implements ItemListener, ActionListener, ConfigurationListener {
    
    /**
     * Item events will be generated by the current agent checkbox and by
     * the checkboxes inside the ItemScrollers.
     */
    public void itemStateChanged(ItemEvent event)
    {
      if (event.getSource() == AgentStateFrame.this.curAgentCheckbox) {
	if (AgentStateFrame.this.curagent != null) {
	  if (event.getStateChange() == ItemEvent.SELECTED)      
	    AgentStateFrame.this.curagent.setEnabled(true);     
	  else
	    AgentStateFrame.this.curagent.setEnabled(false);
	}
	return;
      }
      String name = (String) event.getItem();
      Agent a = AgentStateFrame.this.exec.getActiveAgent(name);
      if (event.getStateChange() == ItemEvent.SELECTED)      
	a.setEnabled(true);     
      else
	a.setEnabled(false);
    }  

    /** 
     * Following 4 methods implement ConfigurationListener.  If a node
     * is created or deleted, the whole state is refreshed.  If a connection is
     * made or broken involving the current agent, then it is redisplayed with
     * the new changes.
     */
    public void nodeCreated(ConfigurationEvent e) 
    {
      refreshState();
    }
    
    public void nodeDeleted(ConfigurationEvent e) 
    { 
      refreshState();
    }
    
    public void connectionMade(ConfigurationEvent e) 
    {
      if (AgentStateFrame.this.curagent == null)
	return;
      if ((e.getAgentFrom() == AgentStateFrame.this.curagent) || (e.getAgentTo() == AgentStateFrame.this.curagent))
	displayAgent(AgentStateFrame.this.curagent.getId());
    }
    
    public void connectionBroken(ConfigurationEvent e) 
    {
      if (AgentStateFrame.this.curagent == null)
	return;
      if ((e.getAgentFrom() == AgentStateFrame.this.curagent) || (e.getAgentTo() == AgentStateFrame.this.curagent))
	displayAgent(AgentStateFrame.this.curagent.getId());
    }
    
    /**
     * ActionEvents are generated by the four buttons in the gui and also by
     * the "Refresh" menu item.  If it is a "refresh" then the state is 
     * refreshed.  Otherwise do what the button's name implies (ie activate all
     * sources, etc.)
     */
    public void actionPerformed(ActionEvent event)
    {
      Object o = event.getSource();
      if (o == AgentStateFrame.this.activateSourcesButton) {
	if ((AgentStateFrame.this.curagent == null) || (AgentStateFrame.this.sources == null))
	  return;
	for (int i=0; i<AgentStateFrame.this.sources.size(); i++) {
	  Module m = (Module) AgentStateFrame.this.sources.elementAt(i);
	  if (!m.isEnabled()) {
	    m.setEnabled(true);
	    AgentStateFrame.this.is1.turnOnItem(m.getId());
	  }
	}
      }
      else if (o == AgentStateFrame.this.deactivateSourcesButton) {
	if ((AgentStateFrame.this.curagent == null) || (AgentStateFrame.this.sources == null))
	  return;
	for (int i=0; i<AgentStateFrame.this.sources.size(); i++) {
	  Module m = (Module) AgentStateFrame.this.sources.elementAt(i);
	  if (m.isEnabled()) {
	    m.setEnabled(false);
	    AgentStateFrame.this.is1.turnOffItem(m.getId());
	  }
	}
      }
      else if (o == AgentStateFrame.this.activateSinksButton) {
	if ((AgentStateFrame.this.curagent == null) || (AgentStateFrame.this.sinks == null))
	  return;
	for (int i=0; i<AgentStateFrame.this.sinks.size(); i++) {
	  Module m = (Module) AgentStateFrame.this.sinks.elementAt(i);
	  if (!m.isEnabled()) {
	    m.setEnabled(true);
	    AgentStateFrame.this.is2.turnOnItem(m.getId());
	  }
	}
      }
      else if (o == AgentStateFrame.this.deactivateSinksButton) {
	if ((AgentStateFrame.this.curagent == null) || (AgentStateFrame.this.sinks == null))
	  return;
	for (int i=0; i<AgentStateFrame.this.sinks.size(); i++) {
	  Module m = (Module) AgentStateFrame.this.sinks.elementAt(i);
	  if (m.isEnabled()) {
	    m.setEnabled(false);
	    AgentStateFrame.this.is2.turnOffItem(m.getId());
	  }
	}
      }
      else if (o == AgentStateFrame.this.refresh) {
	refreshState();
      }
    }
  }


  /**
   * This class listes for events generated by the agent menu items.
   */
  class CheckboxItemListener implements ItemListener {
    
    /**
     * Set the agent that was selected to be the current agent.
     */
    public void itemStateChanged(ItemEvent event) 
    {
      String name = ((CheckboxMenuItem) event.getSource()).getLabel();
	AgentStateFrame.this.displayAgent(name);
    }
  }

  class SymWindow extends java.awt.event.WindowAdapter
  {
    public void windowClosing(java.awt.event.WindowEvent event)
    {
      Object object = event.getSource();
      if (object == AgentStateFrame.this)
	AgentStateFrame_WindowClosing(event);
    }
  }
  

	public void setTitle(String title) {
		super.setTitle("Connections, "+title);
	}
}

