/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.monitor;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import java.net.URLEncoder;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.mitre.pam.interfaces.Sink;
import org.mitre.pam.interfaces.DIM;
import org.mitre.pam.interfaces.Juggler;
import org.mitre.pam.executive.Exec;
import org.mitre.pam.executive.ExecGlobal;
import org.mitre.pam.interfaces.ExecToMonitor;
import org.mitre.pam.interfaces.ExecToController;

import org.mitre.pam.daemon.HasPrintLine;
import org.mitre.pam.daemon.BackWebSubscriber;

/**
* A servlet that displays a list of channels available for subscription
* under Backweb
*
* @author Nazario Irizarry, Jr.
*/
public class SrvBackWebSub extends SrvPAMBase implements HasPrintLine {

	public static final String infoPageURL = "/PAM/BackWeb";
	public static final String allAvailableURL = "/PAM/BackWeb/sub.query";

	private ServletOutputStream printer;
	
    public String getServletInfo() {
		return "Identify available BackWeb channels";
	}

/**
* Services a single request.
*
* @param req the servlet request
* @param req the servlet response
* @exception ServletException when an exception has occurred
*/
	protected void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
			getList(req, res);
	}
	
	
	protected void getList (HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		
		res.setStatus( HttpServletResponse.SC_OK );
		res.setContentType( "text/html" );
		printer = res.getOutputStream();
		
		Enumeration chans = exec.getListOfActiveModules(ExecToMonitor.JUGGLER);
		BackWebSubscriber.makeOutput(this, chans, ExecGlobal.getPeerProtocolHostAndPort()+SrvBackWebSubLive.postURL);
		printer = null;
	}

	
	
	public void println(String s) throws IOException {
		printer.println(s);
	}

	public void print(String s) throws IOException{
		printer.print(s);
	}

	public void flush() throws IOException{
		printer.flush();
	}

}
