/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.monitor;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;


/**
* A servlet that accepts POSTs and returns a BackWeb .iad stuff
*
* @author Nazario Irizarry, Jr.
*/
public class SrvBackWebSubLive extends HttpServlet  {
	public static final String infoPageURL = "/PAM/BackWeb";
	public static final String postURL = "/PAM/BackWeb/sub.post";
	public static final String subscribeInfoURL = "/PAM/BackWeb/index.html";

    public String getServletInfo() {
		return "Subscribe to iPAM BackWeb channels";
	}

/**
* 
* Writes the last part of servlet as its name, followed
* by the message
*
*/
    public void log(String msg) {
		String name = getClass().getName();
		int pos = name.lastIndexOf(".");
		if (pos > 0)
			name = name.substring(pos+1);
		getServletContext().log(name + "\t"+ msg);
    }
/**
* Services a single request.
*
* @param req the servlet request
* @param req the servlet response
* @exception ServletException when an exception has occurred
*/
	protected void doPost (HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		
		
		String[] topicsRequested = req.getParameterValues("channel");
		String backWebHost = req.getParameter("bwHost");
		String backWebTCPPort = req.getParameter("bwTCPPort");
		String backWebUDPPort = req.getParameter("bwUDPPort");
		String exposure = req.getParameter("bwExposure");
		
		res.setContentType( "application/x-iad" );
//		res.setContentType( "text/plain" );
		ServletOutputStream p = res.getOutputStream();

	/*
	* Build subscription file preamble
	*/

				
		res.setStatus( HttpServletResponse.SC_OK );

		p.println("[message-type]");
		p.println("message_type=\"registration\"");
		p.println("[channel]");
		//p.print("name=\""); p.print(channelId); p.println("\"");
		p.print("name=\"");
			p.print(exposure);
			p.println("\"");

//		p.print("description=\""); p.print(channel.getDescription()); p.println("\"");
		p.println("description=\"iPAM Channels\"");
//		p.print("host_name=\""); p.print(backWebHost); p.print(":"); p.print(backWebPort); p.println("\"");
		p.print("host_name=\""); p.print(backWebHost); p.println("\"");
//		p.print("port_number=\""); p.print(backWebPort); p.println("\"");
		p.print("port_number=\""); p.print("370"); p.println("\"");
		p.print("http_port=\""); p.print(backWebTCPPort); p.println("\"");
		p.print("polite_port=\""); p.print(backWebUDPPort); p.println("\"");

		p.print("web_page=\"");
			String page = req.getServerName()+":"+req.getServerPort()+subscribeInfoURL;
//			System.out.println("srv back web sub live page = "+page);
			p.print(page);
			p.println("\"");
		p.println("[user]"); 
	/*
	* Build channel unique fields
	*/
		for (int i = 0; i<topicsRequested.length; i++) {
			p.print(topicsRequested[i]); p.println("=SD,\"subscribed\"");
		}
		p.flush();
	}

    protected long getLastModified (HttpServletRequest req)
    {
		return System.currentTimeMillis();
    }

}
