/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
/* Generated By:JavaCC: Do not edit this line. SimpleSSI.java */
package org.mitre.pam.monitor.ssi;

import java.io.*;
import java.util.Properties;

import org.mitre.pam.executive.Scheduler;

/**
* A class for performing server side substitutions.
* To use this first create an instance of the class with the input stream as argument.  
* Then execute SimpleSSI.doSubstitutions();
* <p>
* <p>
* @version 1, 7 April 1997
* @author Nazario Irizarry, Jr.
*
* modifications
* @version 2, 29 May 1998
* @author Michael DeCorpo
*/
public class SimpleSSI implements SimpleSSIConstants {

        String paramStr;
        PrintStream outStream;
        ResultFile resultStream;
        Properties substitutionVar;
        Properties substitutionFile;
        Properties remaining;

/**
* Main is used for testing purposes only
*/
        public static void main(String args[]) {
                Properties substitutionVar;
                Properties substitutionFile;
                try {
                        substitutionVar= new Properties();
                        substitutionFile= new Properties();
                        SimpleSSI parser;

                        if (true) {
                                substitutionVar.put("CHANNEL_NAME","A Test Channel");
                                substitutionVar.put("CHANNEL_CRITERIA","Many and varied criteria");

                                substitutionFile.put("SEARCH_RESULTS","testhtml/sampleresults.txt");

                                parser = new SimpleSSI(new FileInputStream(new File("channelhtml/resulttemplate.html")), substitutionVar, substitutionFile, substitutionVar, new PrintStream(new FileOutputStream("channelhtml/testout.html")));
                        }
                        else {
                                substitutionVar.put("SKYCOLOR","blue");
                                substitutionVar.put("EARTHCOLOR","green");

                                substitutionFile.put("FILE1","testhtml/subfile1.txt");
                                substitutionFile.put("FILE2","testhtml/subfile2.txt");

                                parser = new SimpleSSI(new FileInputStream(new File("testhtml/test.in")), substitutionVar, substitutionFile, substitutionVar, new PrintStream(new FileOutputStream("testhtml/test.out")));
                        }
                        parser.doSubstitutions();
                }
                catch (FileNotFoundException e) {
                        System.out.println("file not found");
                }
                catch (IOException e) {
                        System.out.println("io exception");
                }
                catch (ParseException e) {
                        System.out.println("parse exception");
                }
        }
/**
* This is the constructor that a typical client should use. Property names are upper case per HTML convention
* for server side includes.  The input file is copied to the output file.  Substitutions are made as
* they are encountered.
* <p>
* @param inStream the input stream (with server side includes)
* @param substitutionVariables The value of the property is inserted directly into the output.
* @param substitutionFiles The contents of the named files are inserted directly into the output. 
* @param outputFileName the name of the output file (with merged results)
*/
//	public SimpleSSI (InputStream inStream, Properties substitutionVariables, Properties substitutionFiles, String outputFileName) {
        public SimpleSSI (InputStream inStream, Properties substitutionVariables, Properties substitutionFiles, Properties allProperties, PrintStream out) {
                this(inStream);

                this.substitutionVar = substitutionVariables;
                this.substitutionFile = substitutionFiles;
                this.remaining = allProperties;
                this.outStream = out;
        }

  final public String notQuote() throws ParseException {
        String str;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case almostAny:
      jj_consume_token(almostAny);
      break;
    case equal:
      jj_consume_token(equal);
      break;
    case ws:
      jj_consume_token(ws);
      break;
    case virtual:
      jj_consume_token(virtual);
      break;
    case file:
      jj_consume_token(file);
      break;
    case var:
      jj_consume_token(var);
      break;
    case include:
      jj_consume_token(include);
      break;
    case echo:
      jj_consume_token(echo);
      break;
    case echoq:
      jj_consume_token(echoq);
      break;
    case bool:
      jj_consume_token(bool);
      break;
    case schedule:
      jj_consume_token(schedule);
      break;
    case leadin:
      jj_consume_token(leadin);
      break;
    case leadout:
      jj_consume_token(leadout);
      break;
    case additional:
      jj_consume_token(additional);
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
         {if (true) return token.image;}
    throw new Error("Missing return statement in function");
  }

  final public String NotLeadout() throws ParseException {
        String str;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case almostAny:
      jj_consume_token(almostAny);
      break;
    case equal:
      jj_consume_token(equal);
      break;
    case virtual:
      jj_consume_token(virtual);
      break;
    case file:
      jj_consume_token(file);
      break;
    case var:
      jj_consume_token(var);
      break;
    case include:
      jj_consume_token(include);
      break;
    case echo:
      jj_consume_token(echo);
      break;
    case echoq:
      jj_consume_token(echoq);
      break;
    case bool:
      jj_consume_token(bool);
      break;
    case schedule:
      jj_consume_token(schedule);
      break;
    case leadin:
      jj_consume_token(leadin);
      break;
    case additional:
      jj_consume_token(additional);
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return token.image;}
    throw new Error("Missing return statement in function");
  }

  final public void any() throws ParseException {
    if (jj_2_1(2)) {
      notQuote();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case quote:
        jj_consume_token(quote);
        break;
      default:
        jj_la1[2] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
          resultStream.print(token.image);
  }

// A parameter may be specified in quotes or not.
  final public String Parameter() throws ParseException {
        String str="";
    if (jj_2_2(2147483647)) {
      str = QuotedString();
                                                 {if (true) return str;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case leadin:
      case echo:
      case echoq:
      case include:
      case bool:
      case schedule:
      case additional:
      case var:
      case file:
      case virtual:
      case equal:
      case almostAny:
        label_1:
        while (true) {
          NotLeadout();
                        str += token.image;
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case leadin:
          case echo:
          case echoq:
          case include:
          case bool:
          case schedule:
          case additional:
          case var:
          case file:
          case virtual:
          case equal:
          case almostAny:
            ;
            break;
          default:
            jj_la1[3] = jj_gen;
            break label_1;
          }
        }
                                                  {if (true) return str;}
        break;
      default:
        jj_la1[4] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public String QuotedString() throws ParseException {
        String str="";
    jj_consume_token(quote);
    label_2:
    while (true) {
      notQuote();
                             str += token.image;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
      case leadin:
      case leadout:
      case echo:
      case echoq:
      case include:
      case bool:
      case schedule:
      case additional:
      case var:
      case file:
      case virtual:
      case equal:
      case almostAny:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_2;
      }
    }
    jj_consume_token(quote);
                                                               {if (true) return str;}
    throw new Error("Missing return statement in function");
  }

  final public void EchoVar() throws ParseException {
    jj_consume_token(echo);
    label_3:
    while (true) {
      jj_consume_token(ws);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_3;
      }
    }
    jj_consume_token(var);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[7] = jj_gen;
        break label_4;
      }
      jj_consume_token(ws);
    }
    jj_consume_token(equal);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[8] = jj_gen;
        break label_5;
      }
      jj_consume_token(ws);
    }
    paramStr = Parameter();
  }

  final public void EchoqVar() throws ParseException {
    jj_consume_token(echoq);
    label_6:
    while (true) {
      jj_consume_token(ws);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[9] = jj_gen;
        break label_6;
      }
    }
    jj_consume_token(var);
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[10] = jj_gen;
        break label_7;
      }
      jj_consume_token(ws);
    }
    jj_consume_token(equal);
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[11] = jj_gen;
        break label_8;
      }
      jj_consume_token(ws);
    }
    paramStr = Parameter();
  }

  final public void IncludeFile() throws ParseException {
    jj_consume_token(include);
    label_9:
    while (true) {
      jj_consume_token(ws);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[12] = jj_gen;
        break label_9;
      }
    }
    jj_consume_token(file);
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[13] = jj_gen;
        break label_10;
      }
      jj_consume_token(ws);
    }
    jj_consume_token(equal);
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[14] = jj_gen;
        break label_11;
      }
      jj_consume_token(ws);
    }
    paramStr = Parameter();
  }

  final public void Boolean() throws ParseException {
    jj_consume_token(bool);
    label_12:
    while (true) {
      jj_consume_token(ws);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[15] = jj_gen;
        break label_12;
      }
    }
    jj_consume_token(var);
    label_13:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[16] = jj_gen;
        break label_13;
      }
      jj_consume_token(ws);
    }
    jj_consume_token(equal);
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[17] = jj_gen;
        break label_14;
      }
      jj_consume_token(ws);
    }
    paramStr = Parameter();
  }

  final public void Additional() throws ParseException {
    jj_consume_token(additional);
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[18] = jj_gen;
        break label_15;
      }
      jj_consume_token(ws);
    }
  }

  final public void Schedule() throws ParseException {
    jj_consume_token(schedule);
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
        ;
        break;
      default:
        jj_la1[19] = jj_gen;
        break label_16;
      }
      jj_consume_token(ws);
    }
  }

  final public void Tag() throws ParseException {
    jj_consume_token(leadin);
    if (jj_2_3(2)) {
      EchoVar();
      jj_consume_token(leadout);
                                      resultStream.substituteVariable(paramStr,false);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case echoq:
        EchoqVar();
        jj_consume_token(leadout);
                                       resultStream.substituteVariable(paramStr,true);
        break;
      case include:
        IncludeFile();
        jj_consume_token(leadout);
                                           resultStream.substituteFile(paramStr);
        break;
      case bool:
        Boolean();
        jj_consume_token(leadout);
                                       resultStream.buildBoolean(paramStr);
        break;
      case additional:
        Additional();
        jj_consume_token(leadout);
                                          resultStream.buildAdditionalTable();
        break;
      case schedule:
        Schedule();
        jj_consume_token(leadout);
                                        Scheduler.buildSchedule(this.outStream,substitutionVar);
        break;
      default:
        jj_la1[20] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void doSubstitutions() throws ParseException {
        try {
                resultStream = new ResultFile(outStream, substitutionVar , substitutionFile, remaining);
        }
        catch (IOException e) {
                throw new ParseException("Cant write to output stream.");
        }
    label_17:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ws:
      case leadin:
      case leadout:
      case echo:
      case echoq:
      case include:
      case bool:
      case schedule:
      case additional:
      case var:
      case file:
      case virtual:
      case quote:
      case equal:
      case almostAny:
        ;
        break;
      default:
        jj_la1[21] = jj_gen;
        break label_17;
      }
      if (jj_2_4(2)) {
        Tag();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ws:
        case leadin:
        case leadout:
        case echo:
        case echoq:
        case include:
        case bool:
        case schedule:
        case additional:
        case var:
        case file:
        case virtual:
        case quote:
        case equal:
        case almostAny:
          any();
          break;
        default:
          jj_la1[22] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
    jj_consume_token(0);

  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_3R_42() {
    if (jj_scan_token(include)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_33() {
    if (jj_scan_token(leadout)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_26() {
    if (jj_scan_token(var)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_35() {
    if (jj_scan_token(ws)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_41() {
    if (jj_scan_token(echoq)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_25() {
    if (jj_scan_token(file)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_32() {
    if (jj_scan_token(leadin)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_19() {
    if (jj_scan_token(echo)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_35()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_scan_token(quote)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_24() {
    if (jj_scan_token(virtual)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_31() {
    if (jj_scan_token(schedule)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_23() {
    if (jj_scan_token(ws)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_30() {
    if (jj_scan_token(bool)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_scan_token(equal)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_29() {
    if (jj_scan_token(echoq)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_20()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_34() {
    if (jj_scan_token(additional)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_28() {
    if (jj_scan_token(echo)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_21() {
    if (jj_scan_token(almostAny)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_18() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_21()) {
    jj_scanpos = xsp;
    if (jj_3R_22()) {
    jj_scanpos = xsp;
    if (jj_3R_23()) {
    jj_scanpos = xsp;
    if (jj_3R_24()) {
    jj_scanpos = xsp;
    if (jj_3R_25()) {
    jj_scanpos = xsp;
    if (jj_3R_26()) {
    jj_scanpos = xsp;
    if (jj_3R_27()) {
    jj_scanpos = xsp;
    if (jj_3R_28()) {
    jj_scanpos = xsp;
    if (jj_3R_29()) {
    jj_scanpos = xsp;
    if (jj_3R_30()) {
    jj_scanpos = xsp;
    if (jj_3R_31()) {
    jj_scanpos = xsp;
    if (jj_3R_32()) {
    jj_scanpos = xsp;
    if (jj_3R_33()) {
    jj_scanpos = xsp;
    if (jj_3R_34()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_40() {
    if (jj_3R_45()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_39() {
    if (jj_3R_44()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_38() {
    if (jj_3R_43()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_37() {
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_36() {
    if (jj_3R_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_3R_19()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_20() {
    if (jj_scan_token(leadin)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_3()) {
    jj_scanpos = xsp;
    if (jj_3R_36()) {
    jj_scanpos = xsp;
    if (jj_3R_37()) {
    jj_scanpos = xsp;
    if (jj_3R_38()) {
    jj_scanpos = xsp;
    if (jj_3R_39()) {
    jj_scanpos = xsp;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_45() {
    if (jj_scan_token(schedule)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_44() {
    if (jj_scan_token(additional)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_43() {
    if (jj_scan_token(bool)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_27() {
    if (jj_scan_token(include)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public SimpleSSITokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[23];
  final private int[] jj_la1_0 = {0xdffe,0xdff4,0x2000,0xdff4,0xdff4,0xdffe,0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x3e0,0xfffe,0xfffe,};
  final private JJSimpleSSICalls[] jj_2_rtns = new JJSimpleSSICalls[4];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public SimpleSSI(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new SimpleSSITokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJSimpleSSICalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJSimpleSSICalls();
  }

  public SimpleSSI(SimpleSSITokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJSimpleSSICalls();
  }

  public void ReInit(SimpleSSITokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJSimpleSSICalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJSimpleSSICalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[16];
    for (int i = 0; i < 16; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 23; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 16; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 4; i++) {
      JJSimpleSSICalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJSimpleSSICalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJSimpleSSICalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

}

final class JJSimpleSSICalls {
  int gen;
  Token first;
  int arg;
  JJSimpleSSICalls next;
}
