/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.monitor.watcher;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;
import java.awt.Point;
import java.awt.Dimension;
import java.util.Random;

import org.mitre.pam.interfaces.PIM;
import org.mitre.pam.interfaces.DIM;
import org.mitre.pam.interfaces.ConnectedAgent;
import org.mitre.pam.interfaces.Reporter;


/**
* A cluster is a group of agents that are connected to each other.
* Two clusters have no agents in common.
* There may only be one cluster if everything is connected to everything.
*
* @author Nazario Irizarry, Jr.
*/
final class SinglesCluster extends Cluster {
	private String clusterId = "singles cluster" + clusterSeq++;

	SinglesCluster(Hashtable allNodes, Reporter reporter) {
		super(allNodes, reporter);
	}

/**
* Do nothing body cause this is nothing to worry about with the
* SinglesCluster
*/
	protected void adjustForHorizontalLineCase1() {
	}
/*
* Assign a layout order left-to-right and top-to-bottom to
* every cluster member.  As this currently stands it gets a sequencing
* which may unnecessarily have a distance of more than one between
* neighbors.  This is because an iteration may push a neighbor without
* moving its community, but this is ok for now.
*/
	void layout() {
		reporter.debugMsg("** Layout cluster :",this,null,null,DEBUG_NAME);
		Enumeration e = items.elements();
		NodeData startNode = null;
		minX = minY = maxX = 0;
		maxY = 3;
	/*
	* set order
	*/
		for (int py = 0; e.hasMoreElements(); py++) {
			for (int px = 0; (px < 4) && e.hasMoreElements(); px++) {
				NodeData node = (NodeData) e.nextElement();
				node.clusterOrderX = px;
				node.clusterOrderY = py;
			}
			maxY = py;
		}

		assignEachNodeAPosition();
		changeCount = 0;
		debugListMembers();
	}
	public String toString() {
		return clusterId;
	}

	void debugListMembers() {
/*
		if (!reporter.isDebugKey(DEBUG_NAME))
			return;
		reporter.debugMsg("List of ",this, null,null, DEBUG_NAME);
		Enumeration e = items.elements();
		while (e.hasMoreElements()) {
			NodeData node = (NodeData) e.nextElement();
			reporter.debugMsg("  -",Integer.toString(node.clusterOrderX),Integer.toString(node.clusterOrderY),node,DEBUG_NAME);
		}
*/
	}
	
/**
* Cluster should not be displayed if it only has one agent
*/
/*
	public boolean shouldBeDisplayed() {
		return true;
	}
*/
}