/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.service.resource;

import org.mitre.pam.interfaces.Agent;

interface AccessibleAgent extends Agent {
/**
* Allows access to the agents super.setProperty()
*/
	public void superSetProperty(String property, String value) ;
/**
* Allows access to the agents consumption model.
*/
	public RateConsumer getModel();
/**
* Allow the pool to notify its consumers that it has been discarded
*/
	public void poolWasDiscarded();
/**
* Interrupt a currently delayed thread and recalculate the delay time
*/
	public void interruptAndRecalculateDelay();
/**
* Is this agent in delay
*/
	public boolean isInDelay();
/**
* Allows pool members to retract bids that may have been
* made to consume files.
*/
	public void retractIfNeeded();
}