// naiupdates.es
//
// ECMAScript that parses McAfee DAT File Version 4.X update page
// URL: http://www.nai.com/asp_set/download/dats/mcafee_4x.asp.
// extracts the current update package and returns it as
// a URL product.
//
// Can be used in conjunction with a GetURL agent PIM to
// get the update page and a NotifyOfChange Juggler to
// send along the product only if a new update is available.
//
// Created by Jason Mathews 9/28/99
//
// Requires: JavaAccess, FileIO

// First define some shortcuts - note that partially expanded
// package names can be assigned. 

PAM = Packages.org.mitre.pam;

// input arguments as named variables:
//
//   agent = instance of ScriptFilter juggler
//   product = product received by ScriptFilter juggler

if (product == null) {
	return null;
}

content = product.getContent();

if (content == null || (javaTypeOf(content) != "org.mitre.pam.store.FileRef")) {
	return null;
}

name = content.getFile();
file = File(name);
file.open();
d = "";
pat = "http://download.mcafee.com/products/datfiles/update/";
while ((s = file.readln()) != null && s != file.eof()) {
 pos = s.indexOf(pat);
 if (pos != -1) {
	end = s.indexOf(".exe", pos);
	if (end != -1) {
		url = s.substring(pos,end+4);
		break;
	}
 } else {
 //  &nbsp;Release: 9/21/99 </b></font></FONT></TD>
 ind = s.indexOf("Release: ");
 if (ind != -1) d = s.substring(ind, ind+17);
 }
} // while

file.close();

if (url != null) {
	outProduct = new PAM.product.view.BasicProduct("McAfee DAT File Version 4.X Update", d);
	outProduct.setContent(new java.net.URL(url));
	return outProduct;
}

return null;
